<?php
// printf ('g=' . $g . ' n=' . $n . ' e=' . $e);

// This formats a specific image/element to be displayed on the screen in HTML.
//
// usage: ?g=July%202006&n=PICT0002&e=jpg

if ($g == '' || $n == '' || $e == '') {
  $img_filename = '';
} else {
  $img_filename = $g . "/" . $n . "." . $e;
}

// Determine file type from $e
switch (strtolower($e)) {
  case "jpg":
    $filetype = 'jpg';
    break;
  case "jpeg":
    $filetype = 'jpg';
    break;
  case "flv":
    $filetype = 'flv';
    break;
  case "tiff":
    $filetype = 'tif';
    break;
  case "tif":
    $filetype = 'tif';
    break;
  case "gif":
    $filetype = 'gif';
    break;
  case "png":
    $filetype = 'png';
    break;
  default:
    $filetype = 'generic';
}

if ($img_filename != '') {
  // Get intrinsic data and EXIF data of current image (if JPEG)
  if (file_exists($media_dir . $img_filename) && $filetype == "jpg") {
    $jpeg_header_data = get_jpeg_header_data($media_dir . $img_filename);
    $jpeg_intrinsic = get_jpeg_intrinsic_values($jpeg_header_data);
    
    // Get Camera related information
    $jpeg_exif = get_EXIF_JPEG($media_dir . $img_filename);
    
    // Get Photoshop related information
    $jpeg_photoshop = get_Photoshop_IRB($jpeg_header_data);   // all the data
    $jpeg_iptc = get_Photoshop_IPTC($jpeg_photoshop);         // parse IPTC
  }
  // TODO: get information for other file types
}

function printNav() {
  global $ftotal, $i, $g, $media_info_filename, $media_dir, $img_filename;
  printf ("<div class=\"nav\">\n");
  printf ("</strong>");
  printf ("<a href=\"?m=i\">");
  printf ("Back To Index");
  printf ("</a></strong> | ");
  // Skip 5: check to see if can co backwards by 5 pictures.
  if ($ftotal) {
    if ($i > 4) {
      printf ("</strong><small><a href=\"");
      printf ("?m=s&g=" . $g . "&i=");
      printf ($i - 5);
      printf ("#nav\">&laquo; Skip 5</a></small></strong>\n");
      printf (" | "); 
    }
  }
  // Prev: check to see, if there are photos to scroll back,
  // if there is, then display a link
  if ($ftotal) {
    if ($i > 0) {
      printf ("<strong><a href=\"");
      printf ("?m=s&g=" . $g .  "&i=");
      printf ($i - 1);
      printf ("#nav\">&laquo; Prev</a></strong>\n");
      printf (" | ");
    }
  }

  // Position: 1 of 29...
  if ($ftotal) {
    printf('<strong>');
    if ($media_info_filename == true) { 
	  printf("<a href=\"" . $media_dir . $img_filename . "\">");
	}
    printf($i + 1);
    if ($media_info_filename == true) {
 	  printf("</a>");
	}
    printf('</strong>');
    printf(' of ');
    printf('<strong>');
    printf("<a href=\"");
    printf("?m=s&g=" . $g . "&i=");
    printf($ftotal - 1);
    printf("#nav\">");
    printf($ftotal);
	printf("</a>");
    printf('</strong>');
  }
  
  // Next: check to see if NEXT button should be available
  if ($ftotal) {
    if (($i + 1) < $ftotal) {
      printf(" | <strong>");
      printf("<a href=\"");
      printf("?m=s&g=" . $g . "&i=");
      printf($i + 1);
      printf("#nav\">Next &raquo;</a></strong>\n");
  // Skip 5: now check if there's over 5 more to go.
      if (($i + 5) < $ftotal) {
        printf(" | ");
        printf("<strong><small><a href=\"");
        printf("?m=s&g=" . $g . "&i=");
        printf($i + 5);
        printf("#nav\">Skip 5 &raquo;</a></small></strong>\n");
      }
    }
  }
  printf ("</div>\n");
}      

// Prints information about a file in the information box. Made to simplify html-writing.
function printinfo($info_name, $info_value, $linktype) {
  global $media_info_link;
  printf("<span class=\"photoinfoname\">" . $info_name);
  if  ($info_name) {
    printf(": ");
  }
  printf("</span><span class=\"photoinfodata\">");
  if ($linktype != "" && $media_info_link) {
    printf("<a href=\"http://www.google.fi/search?q=" . $info_value);
    if ($linktype === 'direct') {
      printf("&btnI"); 
    }
    printf("\" target=\"_blank\">" . $info_value);
    printf("</a>");
  } else {
    printf($info_value);
  }
  printf("</span>\n");
}

?>

<a name="nav"></a>
<table border="0" align="center" cellpadding="0" cellspacing="1" class="photoinfo">
  <tr>
    <td align="center" nowrap colspan="2" class="photoinfo">
      <?php 
        printNav();
      ?>
    </td>
  </tr>
  <tr>
    <td align="center" colspan="2" class="photoinfo">
            <?php
              if ($img_filename != '') {
                if (file_exists($media_dir . $img_filename)) {
                  // File exists. Check to see how the file will be displayed:
                  // TODO: Automatic enumerating of plugins and displaying them
                  // according to how they have to be viewed.
                  switch ($filetype) {
                  case "flv":
                    // Using the excellent flash video player by Jeroen Wijering (http://www.jeroenwijering.com)
                    include_once("system/modules/flvplayer/flv.php");
                    break;
				  case "jpg":
                    imagehtml ($media_dir . $img_filename, $media_photo_width_small, $media_photo_width_full, ' ');
                    break;
				  case "tif":
                    imagehtml ($media_dir . $img_filename, $media_photo_width_small, $media_photo_width_full, ' ');
                    break;
				  case "gif":
                    imagehtml ($media_dir . $img_filename, $media_photo_width_small, $media_photo_width_full, ' ');
                    break;
				  case "png":
                    imagehtml ($media_dir . $img_filename, $media_photo_width_small, $media_photo_width_full, ' ');
                    break;
                  default:
                    printf("Display support not yet implemented.\n");
                  }
                } else {
                // Image isn't available
                printf("<strong>Error: file <em>" . $media_dir . $img_filename . "</em> doesn't exist.</strong>");
                } 
              } else {
                printf("<strong>Error: no filename specified.</strong>");
              }
            ?>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="photoinfo">
	  <div class="photodescription">
		<?php
          // Display Description in EXIF/IPTC tag
          if ($jpeg_exif[0][270]['Tag Name'] and $media_info_exif_description) {
           // exif description...
           printf($jpeg_exif[0][270]['Text Value']);
          } 
          if ($jpeg_iptc[1]['RecData'] and $media_info_iptc_description) {
           // Photoshop description...
           printf($jpeg_iptc[1]['RecData']);
          }
          if ($jpeg_iptc[0]['RecData'] and $media_info_iptc_description) {
           // Picasa2 description, etc...
           printf($jpeg_iptc[0]['RecData']);
          }
        ?>
	  </div>
    </td>
  </tr>
<?php 
  if ($img_description != '') {
    // Custom description
    printf('<tr>');
    printf('<td colspan="2" class="photoinfo">');
    printf('<div align="center">');
    printf('<strong>');
    printf($img_description);
    printf('</strong>');
    printf('</div>');
    printf('</td>');
    printf('</tr>');
  }
?>
  <tr>
    <?php
      // Contains EXIF Information? If so, prepare info table for two columns
      printf('<td valign="top" ');
	  if ( !$jpeg_exif[ 'Tags Name' ] == "TIFF" ) {
	    printf('colspan="2"' );
	  }
      printf('class="photoinfo">');
    ?>
	  
            <?php 
              printf("<div align=\"center\">");
              printf("<span class=\"photoinfoname\"><strong>Target Information</strong></span><br>");
              printf("</div>");
              // Print Copyright Information
              if ($jpeg_exif[0][33432]['Tag Value']) {
                // in exif tag:
                printinfo($jpeg_exif[0][33432]['Tag Name'], $jpeg_exif[0][33432]['Text Value'], false);
                printf("<br>\n");
              } else if ($jpeg_iptc[2]['RecData']) {
                // if not in exif -tag, check the Photoshop record (IPTC in IRB)
                printinfo($jpeg_iptc[2]['RecName'], $jpeg_iptc[2]['RecData'], false);
                printf("<br>\n");
              }
              // Print file name
              if ($media_info_filename == true) {
			    printf("<span class=\"photoinfoname\">Filename: ");
				printf("</span><span class=\"photoinfodata\">");
				printf("<a href=\"" . $media_dir . $img_filename . "\">" . basename($img_filename) . "</a>");
				printf("</span>");
                printf("<br>\n");
              }
              // Print manufacturer information
              if ($jpeg_exif[0][271]['Tag Name']) {
                printinfo($jpeg_exif[0][271]['Tag Name'], $jpeg_exif[0][271]['Text Value'], 'direct');
                // Print the camera model information
                printinfo('', $jpeg_exif[0][272]['Text Value'], true);
                printf("<br>\n");
              }
              // Print the date and time
              if ($jpeg_exif[0][306]['Data'][0]) {
                printinfo('Date', str_replace(":", "/", substr($jpeg_exif[0][306]['Data'][0], 0, 10)), false);
                printinfo('Time', ' ' . substr($jpeg_exif[0][306]['Data'][0], 11, 5), false);
                printf("<br>\n");
              } else {
                // No EXIF information for DATE/TIME, use the date from the last modified date.
                printinfo('Last Modified', date("Y/m/d", filemtime($media_dir . $img_filename)), false);
              }
            ?>
          </td>
            <?php
              // Contains EXIF -information?
              if ( $jpeg_exif[ 'Tags Name' ] == "TIFF" ) {
                printf ("<td valign=\"top\" class=\"photoinfo\">");
                printf("<div align=\"center\">");
                printf("<span class=\"photoinfoname\"><strong>Camera Settings</strong></span><br>");
                printf("</div>");
                // Print ISO Speed Rating
                if ($jpeg_exif[0][34665]['Data'][0][34855]['Tag Name']) {
                  printinfo('ISO Speed Rating', $jpeg_exif[0][34665]['Data'][0][34855]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Exposure Settings
                if ($jpeg_exif[0][34665]['Data'][0][33434]['Tag Name']) {
                  printinfo($jpeg_exif[0][34665]['Data'][0][33434]['Tag Name'], $jpeg_exif[0][34665]['Data'][0][33434]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Apex Exposure Settings
                if ($jpeg_exif[0][34665]['Data'][0][37377]['Tag Name']) {
                  printinfo($jpeg_exif[0][34665]['Data'][0][37377]['Tag Name'], $jpeg_exif[0][34665]['Data'][0][37377]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Exposure Compensation
                if ($jpeg_exif[0][34665]['Data'][0][37380]['Tag Name']) {
                  // printinfo('Exposure Compensation', $jpeg_exif[0][34665]['Data'][0][37380]['Text Value'], false);
                  printinfo('Exposure Compensation', $jpeg_exif[0][34665]['Data'][0][37380]['Text Value'], false);
                  printf("<br>\n");
                }
                // Print Aperture Settings
                if ($jpeg_exif[0][34665]['Data'][0][33437]['Tag Name']) {
                  printinfo('Aperture', $jpeg_exif[0][34665]['Data'][0][33437]['Text Value'], false);
                  printf("<br>\n");
                }
                // // Print Image Size in pixels
                // printinfo('Size', $jpeg_intrinsic['Image Width'] . "x" . $jpeg_intrinsic['Image Height'], false);
                // printf("<br>\n");
                printf ("</td>\n");
              } else {
                // no EXIF available
                printf ("<!-- No EXIF information available -->\n");
              }
            ?>
  </tr>
  <tr>
    <td align="center" nowrap colspan="2" class="photoinfo">
      <?php printNav(); ?>
    </td>
  </tr>
</table>
<?php
  function imagehtml($src, $widthsmall, $widthfull, $caption) {
    // Photo Zoom
	printf ('<a href="#">');
	printf ('<img src="' . $src . '" style="width:' . $widthsmall . 'px;" onclick="piczoom(this)" ');
	printf ('alt="' . $caption . '" title="' . $caption . '">');
	printf ('</a>');
  }
?>